<?php

class Ultimate_AI_TTS
{
  public function __construct()
  {
  }

  public function baseURL()
  {
    return 'https://api.elevenlabs.io';
  }

  public function elevenlabs_get_voices()
  {
    $args = [
      'method' => 'GET',
      'headers' => [
        'Content-Type' => 'application/json',
        'xi-api-key' => get_option('ultimate_ai_elevenlabs_api_key', []),
      ],
    ];
    try {
      $response = wp_remote_post($this->baseURL() . '/v1/voices', $args);
      $res_body = json_decode(wp_remote_retrieve_body($response));

      return [
        'status' => 200,
        'voices' => $res_body,
      ];
    } catch (Exception $e) {
      return [
        'status' => 401,
        'message' => 'Error , ' . $e->getMessage(),
        'voices' => null,
      ];
    }
  }

  public function elevenlabs_create_voice($text_data)
  {
    $model_id = $text_data['model_id'];
    $text = $text_data['text'];
    $voice_id = $text_data['voice_id'];
    $curl = curl_init();
    curl_setopt_array($curl, [
      CURLOPT_URL => 'https://api.elevenlabs.io/v1/text-to-speech/' . $voice_id . '/stream',
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => '',
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 30,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => 'POST',
      CURLOPT_POSTFIELDS => json_encode([
        'model_id' => $model_id,
        'text' => $text,
        'voice_settings' => [
          'similarity_boost' => 0,
          'stability' => 0,
          'use_speaker_boost' => true,
        ],
      ]),
      CURLOPT_HTTPHEADER => [
        'Content-Type: application/json',
        'xi-api-key: 4e24c89b44e865f9498af4a4eaaf6fc9',
      ],
    ]);

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);

    if ($err) {
      return $err;
    } else {
      $upload_dir = wp_upload_dir();
      $audio_dir = str_replace('/', DIRECTORY_SEPARATOR, $upload_dir['path']) . DIRECTORY_SEPARATOR;

      $unique_id = rand();
      // Create the name of the file 
      $file_name = 'ultiamate_ai_audio_' . $unique_id . '.mp3';

      //Save the file in the upload directory.
      $upload_file = file_put_contents($audio_dir . $file_name, $response);
      if ($upload_file == false) {
        return false;
      }


      $attachment = array(
        'post_mime_type' => "audio/mpeg",
        'post_title'     => 'ultiamate_ai_audio_' . $unique_id,
        'post_content'   => '',
        'post_status'    => 'inherit',
        'guid'           => $file_name,
        "meta_input"     => array(
          "tool_type" => "ultimate_ai_audio",
        ),
      );

      $attach_id = wp_insert_attachment($attachment, $upload_dir['path'] . '/' . $file_name);

      return wp_get_attachment_url($attach_id);
    }
  }

  // public function elevenlabs_create_voice($model_id, $voice_id, $text)
  // {
  //     $curl = curl_init();

  //     curl_setopt_array($curl, [
  //       CURLOPT_URL => 'https://api.elevenlabs.io/v1/text-to-speech/21m00Tcm4TlvDq8ikWAM',
  //       CURLOPT_RETURNTRANSFER => true,
  //       CURLOPT_ENCODING => '',
  //       CURLOPT_MAXREDIRS => 10,
  //       CURLOPT_TIMEOUT => 30,
  //       CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  //       CURLOPT_CUSTOMREQUEST => 'POST',
  //       CURLOPT_POSTFIELDS => "{\n  \"model_id\": \"eleven_multilingual_v2\",\n  \"text\": \"Bangladesh, to the east of India on the Bay of Bengal, is a South Asian country marked by lush greenery and many waterways. Its Padma (Ganges), Meghna and Jamuna rivers create fertile plains, and travel by boat is common. On the southern coast, the Sundarbans, an enormous mangrove forest shared with Eastern India, is home to the royal Bengal tiger.\"\n}",
  //       CURLOPT_HTTPHEADER => [
  //         'Content-Type: application/json',
  //         'xi-api-key: 4e24c89b44e865f9498af4a4eaaf6fc9',
  //       ],
  //     ]);

  //     $response = curl_exec($curl);
  //     $err = curl_error($curl);

  //     curl_close($curl);

  //     if ($err) {
  //         echo 'cURL Error #: '.$err;
  //     } else {
  //         // Save the response data to an MP3 file
  //         $mp3Filename = 'output.mp3'; // Define the filename
  //         file_put_contents($mp3Filename, $response); // Save MP3 data to the file

  //         // echo 'MP3 saved as: '.$mp3Filename;
  //     }

  //     // $args = [
  //     //     'method' => 'POST',
  //     //     'headers' => [
  //     //         'Content-Type' => 'application/json',
  //     //         'xi-api-key' => get_option('ultimate_ai_elevenlabs_api_key', []),
  //     //     ],
  //     //     'body' => json_encode([
  //     //         'model_id' => $model_id,
  //     //         'text' => $text,
  //     //     ]),
  //     // ];

  //     // try {
  //     //     $response = wp_remote_post($this->baseURL().'/v1/text-to-speech/'.$voice_id, $args);
  //     //     $res_body = json_decode(wp_remote_retrieve_body($response));

  //     //     return [
  //     //         'status' => 200,
  //     //         'text-to-speech' => $res_body,
  //     //     ];
  //     // } catch (Exception $e) {
  //     //     return [
  //     //         'status' => 401,
  //     //         'message' => 'Error , '.$e->getMessage(),
  //     //         'text-to-speech' => null,
  //     //     ];
  //     // }
  // }
}
